package main

import (
	"flag"
	"time"
)

var (
	source     string
	dest       string
	meta       = []string{"description", "lang", "copyright", "created"} //_ = zord_tree.PopulateTree(cfg.MdTree.Path, cfg.MdTree.DPath, meta)
	customMeta = make(map[string]func() string)
)

func init() {
	flag.StringVar(&dest, "dest", "", "destination directory to read from")
	flag.StringVar(&source, "source", "", "source to collect texts.")
	flag.Parse()

	customMeta["copyright"] = func() string {
		return "CC-BY-SA 4.0"
	}
	customMeta["created"] = func() string {
		currentTime := time.Now()
		return currentTime.Format("2006-01-02")
	}
}

func main() {
	switch action := flag.Arg(0); action {
	case "collect":
		Collect()
	default:
		Run()
	}
}
